module FeynmanDiagramGenerator

using QEDbase
using QEDprocesses

import Base.==

export AbstractTreeLevelFeynmanDiagram, FeynmanVertex
export external_particles, virtual_particles, process, vertices

export Forest

export can_interact
export QED

include("trees/trees.jl")
include("trees/iterator.jl")
include("trees/print.jl")

include("qft/qft.jl")

include("diagrams/interface.jl")
include("diagrams/vertex.jl")
include("diagrams/diagrams.jl")
include("diagrams/iterator.jl")

end # module FeynmanDiagramGenerator
